import java.util.*;

public class GenerateMSP {

    static void generateMSP(int n,int m,double p,int maxD){
	boolean [][] X   = new boolean[m][n];  // X[i][j] <-> agent i is attends meeting j
	int[][] distance = new int[n][n];
	Random gen       = new Random();
	for (int i=0;i<m;i++)
	    for (int j=0;j<n;j++) X[i][j] = (p >= gen.nextDouble());
	for (int i=0;i<n-1;i++)
	    for (int j=i+1;j<n;j++) distance[i][j] = distance[j][i] = 1 + gen.nextInt(maxD);
	System.out.println(n +" "+ m +" "+ (maxD * (n - 1)));
	System.out.println();
	for (int i=0;i<m;i++){
	    System.out.print(i +":");
	    for (int j=0;j<n;j++) if (X[i][j]) System.out.print(" 1"); else System.out.print(" 0");
	    System.out.println();
	}
	System.out.println();
	for (int i=0;i<n;i++){
	    System.out.print(i +":");
	    for (int j=0;j<n;j++) System.out.print(" "+ distance[i][j]);
	    System.out.println();
	}
    }


    public static void main(String[] args){
	if (args.length == 0){System.out.println("java GenerateMSP n-meetings m-agents p-agentsAttends maxD-maxDistance"); return;}
	int n     = Integer.parseInt(args[0]);
	int m     = Integer.parseInt(args[1]);
	double p  = Double.parseDouble(args[2]);
	int maxD  = Integer.parseInt(args[3]);
	generateMSP(n,m,p,maxD);
    }
}
