//
// Convert problem.txt to dzn format
//
import java.io.*;
import java.util.*;

public class toDzn {

    static int[][] distance; // travel distance between meetings
    static int[][] attends; // attends[i][j] <-> agent_i is at meeting_j
    static int n,m,timeSlots;
    static Scanner sc;

    static void skip(int k){
	for (int i=0;i<k;i++) sc.next();
    }

    static void readMSP(String fname) throws IOException {
	sc           = new Scanner(new File(fname));
	n            = sc.nextInt();       // number of meetings
	m            = sc.nextInt();       // number of agents
	timeSlots    = sc.nextInt();       // number of time slots
	attends      = new int[m][n];      // attends[i][j] <-> agent i is attends meeting j
	distance     = new int[n][n];
	
	for (int i=0;i<m;i++){
	    skip(1);
	    for (int j=0;j<n;j++) attends[i][j] = sc.nextInt();
	}
	for (int i=0;i<n;i++){
	    skip(1);
	    for (int j=0;j<n;j++) distance[i][j] = sc.nextInt(); 
	}
	sc.close();
    }

    static void convert(){
	System.out.println("n = "+ n +";");
	System.out.println("m = "+ m +";");
	System.out.println("timeSlots = "+ timeSlots +";");
	
	System.out.print("attends = [");
	for (int p=0;p<m;p++){
	    System.out.print("|"+ attends[p][0]);
	    for (int i=1;i<n;i++) System.out.print(","+ attends[p][i]);
	    System.out.println();
	}
	System.out.println("|];");
	
	System.out.print("distance = [");
	for (int i=0;i<n;i++){
	    System.out.print("|"+ distance[i][0]);
	    for (int j=1;j<n;j++) System.out.print(","+ distance[i][j]);
	    System.out.println();
	}
	System.out.println("|];");
    }
    
    public static void main(String[] args)  throws IOException {
	readMSP(args[0]);
	convert();
    }
}	
